/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package vista;

import java.util.Objects;
import javax.swing.JOptionPane;
import javax.swing.WindowConstants;
import logic.PersonLogic;
import modelo.dto.PersonaDto;

/**
 *
 * @author cartu
 */
public class PersonaDialog extends javax.swing.JDialog {
    
    
    private final PersonLogic personLogic = new PersonLogic();
    private String operation = "";
    private Integer id;

    /**
     * Creates new form PersonaDialog
     */
    public PersonaDialog(java.awt.Frame parent, boolean modal, Integer id) {
        super(parent, modal);
        initComponents();
        this.operation = Objects.isNull(id) ? "Nuevo" : "Editar";
        this.id = id;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        TextFieldDNI = new javax.swing.JTextField();
        TextFieldNombres = new javax.swing.JTextField();
        TextFieldApellidos = new javax.swing.JTextField();
        btnGuardar = new javax.swing.JButton();
        btnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jLabel1.setText("DNI");

        jLabel2.setText("Nombres");

        jLabel3.setText("Apellidos");

        TextFieldDNI.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                TextFieldDNIKeyTyped(evt);
            }
        });

        btnGuardar.setText("Guardar");
        btnGuardar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnGuardarActionPerformed(evt);
            }
        });

        btnCancelar.setText("Cancelar");
        btnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2)
                            .addComponent(jLabel3))
                        .addGap(32, 32, 32)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(TextFieldApellidos, javax.swing.GroupLayout.DEFAULT_SIZE, 245, Short.MAX_VALUE)
                            .addComponent(TextFieldNombres)
                            .addComponent(TextFieldDNI, javax.swing.GroupLayout.PREFERRED_SIZE, 125, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(100, 100, 100)
                        .addComponent(btnGuardar)
                        .addGap(26, 26, 26)
                        .addComponent(btnCancelar)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(21, 21, 21)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(TextFieldDNI, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(TextFieldNombres, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(25, 25, 25)
                        .addComponent(jLabel3))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addComponent(TextFieldApellidos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(25, 25, 25)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnGuardar)
                    .addComponent(btnCancelar))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnGuardarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnGuardarActionPerformed
        if(operation.equals("Nuevo"))
            guardarDatos();
        else if (operation.equals("Editar"))
            editarDatos();
    }//GEN-LAST:event_btnGuardarActionPerformed

    private void btnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelarActionPerformed
        // TODO add your handling code here:
        this.setVisible(false);
    }//GEN-LAST:event_btnCancelarActionPerformed

    private void TextFieldDNIKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_TextFieldDNIKeyTyped
        if (TextFieldDNI.getText().length() < 8) {
            ingresoNumero(evt);
        } else {
            evt.consume();
        }
    }//GEN-LAST:event_TextFieldDNIKeyTyped
    
    public static final void ingresoNumero(java.awt.event.KeyEvent evt) {
        Character c = evt.getKeyChar();
        // Verificar si la tecla pulsada es un digito
        if (!Character.isDigit(c)) {
            evt.consume();
        }
    }
    
    public void guardarDatos(){
        boolean valido = validarEntrada();
        
        if(valido){
            PersonaDto personaDto = new PersonaDto();
            personaDto.setDni(TextFieldDNI.getText());
            personaDto.setNombre(TextFieldNombres.getText());
            personaDto.setApellidos(TextFieldApellidos.getText());
            personLogic.create(personaDto);
            JOptionPane.showMessageDialog(this, "Registro guardado correctamente", "GUARDADO!", JOptionPane.INFORMATION_MESSAGE);
            this.setVisible(false);
        }else{
            JOptionPane.showMessageDialog(this, "Es necesario llenar los campos" , "Atención!", JOptionPane.WARNING_MESSAGE);
        }
        
    }
    
    public void editarDatos(){
        boolean valido = validarEntrada();
        
        if(valido){
            PersonaDto personaDto = new PersonaDto();
            personaDto.setDni(TextFieldDNI.getText());
            personaDto.setNombre(TextFieldNombres.getText());
            personaDto.setApellidos(TextFieldApellidos.getText());
            personLogic.update(id, personaDto);
            JOptionPane.showMessageDialog(this, "Registro actualizado correctamente", "ACTUALIZADO!", JOptionPane.INFORMATION_MESSAGE);
            this.setVisible(false);
        }else{
            JOptionPane.showMessageDialog(this, "Es necesario llenar los campos" , "Atención!", JOptionPane.WARNING_MESSAGE);
        }
    }
    
    
    private boolean validarEntrada(){
        int dniLength = TextFieldDNI.getText().length();
        int nombresLength = TextFieldNombres.getText().length();
        int apellidosLength = TextFieldApellidos.getText().length();
        return dniLength != 0 && nombresLength != 0 && apellidosLength != 0;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField TextFieldApellidos;
    private javax.swing.JTextField TextFieldDNI;
    private javax.swing.JTextField TextFieldNombres;
    private javax.swing.JButton btnCancelar;
    private javax.swing.JButton btnGuardar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    // End of variables declaration//GEN-END:variables
}
